# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from galv.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    ACCESS_LEVELS_ = "/access_levels/"
    ACTIVATE_ = "/activate/"
    ADDITIONAL_STORAGE_ = "/additional_storage/"
    ADDITIONAL_STORAGE_ID_ = "/additional_storage/{id}/"
    ADDITIONAL_STORAGE_DESCRIBE_ = "/additional_storage/describe/"
    ARBITRARY_FILES_ = "/arbitrary_files/"
    ARBITRARY_FILES_ID_ = "/arbitrary_files/{id}/"
    ARBITRARY_FILES_ID_FILE_ = "/arbitrary_files/{id}/file/"
    ARBITRARY_FILES_DESCRIBE_ = "/arbitrary_files/describe/"
    CELL_CHEMISTRIES_ = "/cell_chemistries/"
    CELL_CHEMISTRIES_DESCRIBE_ = "/cell_chemistries/describe/"
    CELL_FAMILIES_ = "/cell_families/"
    CELL_FAMILIES_ID_ = "/cell_families/{id}/"
    CELL_FAMILIES_DESCRIBE_ = "/cell_families/describe/"
    CELL_FORM_FACTORS_ = "/cell_form_factors/"
    CELL_FORM_FACTORS_DESCRIBE_ = "/cell_form_factors/describe/"
    CELL_MANUFACTURERS_ = "/cell_manufacturers/"
    CELL_MANUFACTURERS_DESCRIBE_ = "/cell_manufacturers/describe/"
    CELL_MODELS_ = "/cell_models/"
    CELL_MODELS_DESCRIBE_ = "/cell_models/describe/"
    CELLS_ = "/cells/"
    CELLS_ID_ = "/cells/{id}/"
    CELLS_ID_RDF_ = "/cells/{id}/rdf/"
    CELLS_DESCRIBE_ = "/cells/describe/"
    COLUMN_MAPPINGS_ = "/column_mappings/"
    COLUMN_MAPPINGS_ID_ = "/column_mappings/{id}/"
    COLUMN_MAPPINGS_DESCRIBE_ = "/column_mappings/describe/"
    COLUMN_TYPES_ = "/column_types/"
    COLUMN_TYPES_ID_ = "/column_types/{id}/"
    COLUMN_TYPES_DESCRIBE_ = "/column_types/describe/"
    CREATE_TOKEN_ = "/create_token/"
    CYCLER_TESTS_ = "/cycler_tests/"
    CYCLER_TESTS_ID_ = "/cycler_tests/{id}/"
    CYCLER_TESTS_DESCRIBE_ = "/cycler_tests/describe/"
    DUMP_ID_ = "/dump/{id}/"
    EQUIPMENT_ = "/equipment/"
    EQUIPMENT_ID_ = "/equipment/{id}/"
    EQUIPMENT_DESCRIBE_ = "/equipment/describe/"
    EQUIPMENT_FAMILIES_ = "/equipment_families/"
    EQUIPMENT_FAMILIES_ID_ = "/equipment_families/{id}/"
    EQUIPMENT_FAMILIES_DESCRIBE_ = "/equipment_families/describe/"
    EQUIPMENT_MANUFACTURERS_ = "/equipment_manufacturers/"
    EQUIPMENT_MANUFACTURERS_DESCRIBE_ = "/equipment_manufacturers/describe/"
    EQUIPMENT_MODELS_ = "/equipment_models/"
    EQUIPMENT_MODELS_DESCRIBE_ = "/equipment_models/describe/"
    EQUIPMENT_TYPES_ = "/equipment_types/"
    EQUIPMENT_TYPES_DESCRIBE_ = "/equipment_types/describe/"
    EXPERIMENTS_ = "/experiments/"
    EXPERIMENTS_ID_ = "/experiments/{id}/"
    EXPERIMENTS_DESCRIBE_ = "/experiments/describe/"
    FILES_ = "/files/"
    FILES_ID_ = "/files/{id}/"
    FILES_ID_APPLICABLE_MAPPINGS_ = "/files/{id}/applicable_mappings/"
    FILES_ID_EXTRA_METADATA_ = "/files/{id}/extra_metadata/"
    FILES_ID_PNG_ = "/files/{id}/png/"
    FILES_ID_REIMPORT_ = "/files/{id}/reimport/"
    FILES_ID_SUMMARY_ = "/files/{id}/summary/"
    FILES_DESCRIBE_ = "/files/describe/"
    FORGOT_PASSWORD_ = "/forgot_password/"
    GALV_STORAGE_ = "/galv_storage/"
    GALV_STORAGE_ID_ = "/galv_storage/{id}/"
    GALV_STORAGE_DESCRIBE_ = "/galv_storage/describe/"
    HARVEST_ERRORS_ = "/harvest_errors/"
    HARVEST_ERRORS_ID_ = "/harvest_errors/{id}/"
    HARVEST_ERRORS_DESCRIBE_ = "/harvest_errors/describe/"
    HARVESTERS_ = "/harvesters/"
    HARVESTERS_ID_ = "/harvesters/{id}/"
    HARVESTERS_DESCRIBE_ = "/harvesters/describe/"
    LABS_ = "/labs/"
    LABS_ID_ = "/labs/{id}/"
    LABS_DESCRIBE_ = "/labs/describe/"
    LOGIN_ = "/login/"
    MONITORED_PATHS_ = "/monitored_paths/"
    MONITORED_PATHS_ID_ = "/monitored_paths/{id}/"
    MONITORED_PATHS_DESCRIBE_ = "/monitored_paths/describe/"
    PARQUET_PARTITIONS_ = "/parquet_partitions/"
    PARQUET_PARTITIONS_ID_ = "/parquet_partitions/{id}/"
    PARQUET_PARTITIONS_ID_FILE_ = "/parquet_partitions/{id}/file/"
    PARQUET_PARTITIONS_DESCRIBE_ = "/parquet_partitions/describe/"
    RESET_PASSWORD_ = "/reset_password/"
    SCHEDULE_FAMILIES_ = "/schedule_families/"
    SCHEDULE_FAMILIES_ID_ = "/schedule_families/{id}/"
    SCHEDULE_FAMILIES_DESCRIBE_ = "/schedule_families/describe/"
    SCHEDULE_IDENTIFIERS_ = "/schedule_identifiers/"
    SCHEDULE_IDENTIFIERS_DESCRIBE_ = "/schedule_identifiers/describe/"
    SCHEDULES_ = "/schedules/"
    SCHEDULES_ID_ = "/schedules/{id}/"
    SCHEDULES_DESCRIBE_ = "/schedules/describe/"
    SCHEMA_VALIDATIONS_ = "/schema_validations/"
    SCHEMA_VALIDATIONS_ID_ = "/schema_validations/{id}/"
    SCHEMA_VALIDATIONS_DESCRIBE_ = "/schema_validations/describe/"
    TEAMS_ = "/teams/"
    TEAMS_ID_ = "/teams/{id}/"
    TEAMS_DESCRIBE_ = "/teams/describe/"
    TOKENS_ = "/tokens/"
    TOKENS_ID_ = "/tokens/{id}/"
    TOKENS_DESCRIBE_ = "/tokens/describe/"
    UNITS_ = "/units/"
    UNITS_ID_ = "/units/{id}/"
    UNITS_DESCRIBE_ = "/units/describe/"
    USERS_ = "/users/"
    USERS_ID_ = "/users/{id}/"
    USERS_DESCRIBE_ = "/users/describe/"
    VALIDATION_SCHEMAS_ = "/validation_schemas/"
    VALIDATION_SCHEMAS_ID_ = "/validation_schemas/{id}/"
    VALIDATION_SCHEMAS_DESCRIBE_ = "/validation_schemas/describe/"
    VALIDATION_SCHEMAS_KEYS_ = "/validation_schemas/keys/"
